package org.openxma.demo.customer.xma.jsfcomponent.backingbean;

import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

/** 
 * Backing Bean for Page ExpressionsStringsPage 
 */
@Component("expressionsStringsPage")
@Scope("access")
public class ExpressionsStringsPage extends ExpressionsStringsPageGen {
	
	@Override
	public void dataModelInit() {
		mode = "view";
	}

	@Override
	public void setViewMode() {
		mode = "view";
	}

	@Override
	public void setEditMode() {
		mode = "edit";
		
	}
}
