package org.openxma.demo.customer.xma.jsfcomponent.backingbean;
import javax.annotation.PostConstruct;
import javax.faces.component.UIViewRoot;
import javax.faces.context.FacesContext;
import javax.faces.event.ComponentSystemEvent;
import org.openxma.dsl.platform.jsf.beans.PageBackingBean;
import org.springframework.beans.factory.annotation.Autowired;
/** 
 * Abstract Backing Bean Base for Page ExpressionsStringsPage 
 */
public abstract class ExpressionsStringsPageGen extends PageBackingBean {
	
	// client id constants
	
	public static String SET_VIEW_MODE_BUTTON_ID = "ExpressionsStringsPageForm:setViewModeButton";
	public static String SET_EDIT_MODE_BUTTON_ID = "ExpressionsStringsPageForm:setEditModeButton";
	
	
	@Autowired
	protected JsfComponent component;
	
	public JsfComponent getTypedComponent() {
		return component;
	}
	
	protected String mode;
	
	
    // data objects
    
    // jsf data models
    
    // init data model
    protected void dataModelInit() {
    }
    
    // lifecycle events
    @PostConstruct
    public void beanInit() {
    	dataModelInit();
    	onInit();
    	onEnter();
    }
    
    public void invoke() {
    	onInit();
    	onEnter();
    }
    /**
     * PML onLoad event
     */
    protected void onEnter() {
    }
    
    /**
     * PML onLeave event
     */
    protected void onLeave() {
    }
    
    /**
     * PML onInit event
     */
    protected void onInit() {
    }
    
    // commands
	public abstract void setViewMode();
	public abstract void setEditMode();
    
    // conditions

    public String getMode() {
        return mode;
    }
    public void setMode(String mode) {
        this.mode = mode;
    }

	
	public void handlePreRenderView(ComponentSystemEvent event){
		processConditions();
		if (!FacesContext.getCurrentInstance().isPostback()) {
			customizeView(FacesContext.getCurrentInstance().getViewRoot());
		}
	}
	
	protected void customizeView(UIViewRoot viewRoot) {
		//by default do nothing, override to add behaviour
	}
	protected ExpressionsStringsPageGen getContext() {
		return this;
	}
	protected void processConditions() {
	}

}
