package org.openxma.demo.customer.xma.jsfcomponent.backingbean;

import org.apache.myfaces.orchestra.viewController.annotations.ViewController;
import static org.openxma.dsl.platform.jsf.util.JsfUtil.addMessage;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;


/** 
 * Backing Bean for Page RemoteCallsPage 
 */
@Component("remoteCallsPage")
@Scope("access")
@ViewController(viewIds={"pages/JsfComponent/remoteCallsPage.xhtml"})
public class RemoteCallsPage extends RemoteCallsPageGen {

	@Override
	public void myServerMethod() {
		System.out.println("My Server Method");
		addMessage(null, "Remote Call", "Method called");
	}

	@Override
	public void myServerMethodDirect() {
		System.out.println("My Server Method Direct ");
		addMessage(null, "Remote Call", "Method called (Direct)");
	}
}
