package org.openxma.demo.customer.xma.jsfcomponent.backingbean;
import javax.annotation.PostConstruct;
import javax.faces.component.UIViewRoot;
import javax.faces.context.FacesContext;
import javax.faces.event.ComponentSystemEvent;
import org.openxma.demo.customer.dto.CustomerView;
import org.openxma.dsl.platform.jsf.beans.PageBackingBean;
import org.springframework.beans.factory.annotation.Autowired;
/** 
 * Abstract Backing Bean Base for Page ValidationPage 
 */
public abstract class ValidationPageGen extends PageBackingBean {
	
	// client id constants
	
	public static String P_ID = "ValidationPageForm:p";
	public static String SEND_FORM_BUTTON_ID = "ValidationPageForm:sendFormButton";
	
	
	@Autowired
	protected JsfComponent component;
	
	public JsfComponent getTypedComponent() {
		return component;
	}
	
	
	
    // data objects
    protected CustomerView cus;
    
    // jsf data models
    
    // init data model
    protected void dataModelInit() {
    }
    
    // lifecycle events
    @PostConstruct
    public void beanInit() {
    	dataModelInit();
    	onInit();
    	onEnter();
    }
    
    public void invoke() {
    	onInit();
    	onEnter();
    }
    /**
     * PML onLoad event
     */
    protected void onEnter() {
    }
    
    /**
     * PML onLeave event
     */
    protected void onLeave() {
    }
    
    /**
     * PML onInit event
     */
    protected void onInit() {
    }
    
    // commands
	public abstract void sendForm();
    
    // conditions


	public CustomerView getCus() {
	    return cus;
	}
	public void setCus(CustomerView cus) {
	    this.cus = cus;
	}
	
	public void handlePreRenderView(ComponentSystemEvent event){
		processConditions();
		if (!FacesContext.getCurrentInstance().isPostback()) {
			customizeView(FacesContext.getCurrentInstance().getViewRoot());
		}
	}
	
	protected void customizeView(UIViewRoot viewRoot) {
		//by default do nothing, override to add behaviour
	}
	protected ValidationPageGen getContext() {
		return this;
	}
	protected void processConditions() {
	}

}
