package org.openxma.demo.customer.xma.jsfcomponent.backingbean;
import java.util.List;
import javax.annotation.PostConstruct;
import javax.faces.component.UIViewRoot;
import javax.faces.context.FacesContext;
import javax.faces.event.ComponentSystemEvent;
import javax.faces.model.SelectItem;
import org.openxma.dsl.platform.jsf.beans.PageBackingBean;
import org.primefaces.model.TreeNode;
import org.springframework.beans.factory.annotation.Autowired;
/** 
 * Abstract Backing Bean Base for Page WidgetsPage 
 */
public abstract class WidgetsPageGen extends PageBackingBean {
	
	// client id constants
	
	public static String MYTEXT_ID = "WidgetsPageForm:mytext1";
	public static String MYDISABLEDTEXT_ID = "WidgetsPageForm:mydisabledtext1";
	public static String MYCOMBO_ID = "WidgetsPageForm:mycombo1";
	public static String MYDISABLEDCOMBO_ID = "WidgetsPageForm:mydisabledcombo1";
	public static String MYCHECK_ID = "WidgetsPageForm:mycheck1";
	public static String MYDISABLEDCHECK_ID = "WidgetsPageForm:mydisabledcheck1";
	public static String MYLISTBOX_ID = "WidgetsPageForm:mylistbox1";
	public static String MYDISABLEDLISTBOX_ID = "WidgetsPageForm:mydisabledlistbox1";
	public static String SEND_BUTTON_ID = "WidgetsPageForm:sendButton";
	public static String DISABLED_BUTTON_ID = "WidgetsPageForm:disabledButton";
	
	
	@Autowired
	protected JsfComponent component;
	
	public JsfComponent getTypedComponent() {
		return component;
	}
	
	
	
    // data objects
    
    // jsf data models
    protected String mytextText = "";
    
    public String getMytextText() {
        return mytextText;
    }
    public void setMytextText(String mytextText) {
        this.mytextText = mytextText;
    }
    protected String mydisabledtextText = "";
    
    public String getMydisabledtextText() {
        return mydisabledtextText;
    }
    public void setMydisabledtextText(String mydisabledtextText) {
        this.mydisabledtextText = mydisabledtextText;
    }
    protected List<SelectItem> mycombo1SelectItems;
    		
    public List getMycombo1SelectItems() {
        return mycombo1SelectItems;
    }
    public void setMycombo1SelectItems(List mycombo1SelectItems) {
        this.mycombo1SelectItems = mycombo1SelectItems;
    }
    
    protected Object mycomboCombo;
    
    public Object getMycomboCombo() {
        return mycomboCombo;
    }
    public void setMycomboCombo(Object mycomboCombo) {
        this.mycomboCombo = mycomboCombo;
    }
    protected List<SelectItem> mydisabledcombo1SelectItems;
    		
    public List getMydisabledcombo1SelectItems() {
        return mydisabledcombo1SelectItems;
    }
    public void setMydisabledcombo1SelectItems(List mydisabledcombo1SelectItems) {
        this.mydisabledcombo1SelectItems = mydisabledcombo1SelectItems;
    }
    
    protected Object mydisabledcomboCombo;
    
    public Object getMydisabledcomboCombo() {
        return mydisabledcomboCombo;
    }
    public void setMydisabledcomboCombo(Object mydisabledcomboCombo) {
        this.mydisabledcomboCombo = mydisabledcomboCombo;
    }
    protected Boolean mycheckSelected = false;
    
    public Boolean getMycheckSelected() {
        return mycheckSelected;
    }
    public void setMycheckSelected(Boolean mycheckSelected) {
        this.mycheckSelected = mycheckSelected;
    }
    protected Boolean mydisabledcheckSelected = false;
    
    public Boolean getMydisabledcheckSelected() {
        return mydisabledcheckSelected;
    }
    public void setMydisabledcheckSelected(Boolean mydisabledcheckSelected) {
        this.mydisabledcheckSelected = mydisabledcheckSelected;
    }
    protected List<SelectItem> mylistbox1SelectItems;
    		
    public List getMylistbox1SelectItems() {
        return mylistbox1SelectItems;
    }
    public void setMylistbox1SelectItems(List mylistbox1SelectItems) {
        this.mylistbox1SelectItems = mylistbox1SelectItems;
    }
    
    protected Object mylistboxListBox;
    
    public Object getMylistboxListBox() {
        return mylistboxListBox;
    }
    public void setMylistboxListBox(Object mylistboxListBox) {
        this.mylistboxListBox = mylistboxListBox;
    }
    protected List<SelectItem> mydisabledlistbox1SelectItems;
    		
    public List getMydisabledlistbox1SelectItems() {
        return mydisabledlistbox1SelectItems;
    }
    public void setMydisabledlistbox1SelectItems(List mydisabledlistbox1SelectItems) {
        this.mydisabledlistbox1SelectItems = mydisabledlistbox1SelectItems;
    }
    
    protected Object mydisabledlistboxListBox;
    
    public Object getMydisabledlistboxListBox() {
        return mydisabledlistboxListBox;
    }
    public void setMydisabledlistboxListBox(Object mydisabledlistboxListBox) {
        this.mydisabledlistboxListBox = mydisabledlistboxListBox;
    }
    protected TreeNode mytreeTreeRootNode;
    protected TreeNode mytreeTreeSelectedNode;
    
    public TreeNode getMytreeTreeRootNode() {
        return mytreeTreeRootNode;
    }
    public void setMytreeTreeRootNode(TreeNode mytreeTreeRootNode) {
        this.mytreeTreeRootNode = mytreeTreeRootNode;
    }
    public TreeNode getMytreeTreeSelectedNode() {
        return mytreeTreeSelectedNode;
    }
    public void setMytreeTreeSelectedNode(TreeNode mytreeTreeSelectedNode) {
        this.mytreeTreeSelectedNode = mytreeTreeSelectedNode;
    }
    
    // init data model
    protected void dataModelInit() {
    }
    
    // lifecycle events
    @PostConstruct
    public void beanInit() {
    	dataModelInit();
    	onInit();
    	onEnter();
    }
    
    public void invoke() {
    	onInit();
    	onEnter();
    }
    /**
     * PML onLoad event
     */
    protected void onEnter() {
    }
    
    /**
     * PML onLeave event
     */
    protected void onLeave() {
    }
    
    /**
     * PML onInit event
     */
    protected void onInit() {
            init();
    }
    
    // commands
	public abstract void init();
	public abstract void send();
    
    // conditions


	
	public void handlePreRenderView(ComponentSystemEvent event){
		processConditions();
		if (!FacesContext.getCurrentInstance().isPostback()) {
			customizeView(FacesContext.getCurrentInstance().getViewRoot());
		}
	}
	
	protected void customizeView(UIViewRoot viewRoot) {
		//by default do nothing, override to add behaviour
	}
	protected WidgetsPageGen getContext() {
		return this;
	}
	protected void processConditions() {
	}

}
