package org.openxma.demo.customer.xma.layout.backingbean;
import at.spardat.xma.session.XMASession;
import javax.annotation.PostConstruct;
import javax.faces.component.UIViewRoot;
import javax.faces.context.FacesContext;
import javax.faces.event.ComponentSystemEvent;
import org.openxma.dsl.platform.jsf.beans.PageBackingBean;
import org.springframework.beans.factory.annotation.Autowired;
/** 
 * Abstract Backing Bean Base for Page BasicLayout 
 */
public abstract class BasicLayoutGen extends PageBackingBean {
	
	@Autowired
	protected Layout component;
	@Autowired
	protected XMASession xmaSession;
	
	public Layout getTypedComponent() {
		return component;
	}
	
	
    // data objects
    
    // jsf data models
    
    // init data model
    protected void dataModelInit() {
    }
    
    // lifecycle events
    @PostConstruct
    public void beanInit() {
    	dataModelInit();
    	onInit();
    	onEnter();
    }
    
    public void invoke() {
    	onInit();
    	onEnter();
    }
    /**
     * PML onLoad event
     */
    protected void onEnter() {
    }
    
    /**
     * PML onLeave event
     */
    protected void onLeave() {
    }
    
    /**
     * PML onInit event
     */
    protected void onInit() {
    }
    
    // commands
    
    // conditions


	
	public void handlePreRenderView(ComponentSystemEvent event){
		if (!FacesContext.getCurrentInstance().isPostback()) {
			customizeView(FacesContext.getCurrentInstance().getViewRoot());
		}
	}
	
	protected void customizeView(UIViewRoot viewRoot) {
		//by default do nothing, override to add behaviour
	}

}
