package org.openxma.demo.customer.xma.securitycomponent.backingbean;
import javax.annotation.PostConstruct;
import javax.faces.component.UIViewRoot;
import javax.faces.context.FacesContext;
import javax.faces.event.ComponentSystemEvent;
import org.openxma.dsl.platform.jsf.beans.PageBackingBean;
import org.springframework.beans.factory.annotation.Autowired;
/** 
 * Abstract Backing Bean Base for Page XSSPage 
 */
public abstract class XSSPageGen extends PageBackingBean {
	
	@Autowired
	protected SecurityComponent component;
	
	public SecurityComponent getTypedComponent() {
		return component;
	}
	
	
    // data objects
    
    // jsf data models
    protected String mytextText = "";
    
    public String getMytextText() {
        return mytextText;
    }
    public void setMytextText(String mytextText) {
        this.mytextText = mytextText;
    }
    
    // init data model
    protected void dataModelInit() {
    }
    
    // lifecycle events
    @PostConstruct
    public void beanInit() {
    	dataModelInit();
    	onInit();
    	onEnter();
    }
    
    public void invoke() {
    	onInit();
    	onEnter();
    }
    /**
     * PML onLoad event
     */
    protected void onEnter() {
    }
    
    /**
     * PML onLeave event
     */
    protected void onLeave() {
    }
    
    /**
     * PML onInit event
     */
    protected void onInit() {
    }
    
    // commands
	public abstract void send();
    
    // conditions


	
	public void handlePreRenderView(ComponentSystemEvent event){
		processConditions();
		if (!FacesContext.getCurrentInstance().isPostback()) {
			customizeView(FacesContext.getCurrentInstance().getViewRoot());
		}
	}
	
	protected void customizeView(UIViewRoot viewRoot) {
		//by default do nothing, override to add behaviour
	}
	protected XSSPageGen getContext() {
		return this;
	}
	protected void processConditions() {
	}

}
