package org.openxma.dsl.platform.jsf.page;


import java.util.Map;

import javax.faces.context.FacesContext;

import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;

@Controller
@Scope("request")
public class ErrorPage {

	// TODO: load all error page messages from resource bundle
	// go up and up in root cause
	// if there is a message for a specific exception type, use it!
	private static final String BR = "\n";

	public String getStackTrace() {
		FacesContext context = FacesContext.getCurrentInstance();
		Map<String, Object> map = context.getExternalContext().getRequestMap();
		Throwable throwable = (Throwable) map
				.get("javax.servlet.error.exception");
		StringBuilder builder = new StringBuilder();
		builder.append(throwable.getMessage()).append(BR);

		for (StackTraceElement element : throwable.getStackTrace()) {
			builder.append(element).append(BR);
		}

		return builder.toString();
	}
}

