package org.openxma.demo.customer.model;

import java.math.BigDecimal;
import java.util.Date;
import org.openxma.demo.customer.Address;
import org.openxma.demo.customer.CategoryEnum;

public interface CustomerGen  {

	String getOid();
	void setOid(String oid);

	Date getVersion();
	void setVersion(Date version);

	String getFirstName();
	void setFirstName(String firstName);

	String getLastName();
	void setLastName(String lastName);

	String getEmailAddress();
	void setEmailAddress(String emailAddress);

	Date getBirthDate();
	void setBirthDate(Date birthDate);

	Address getInvoiceAddress();
	void setInvoiceAddress(Address invoiceAddress);

	Address getDeliveryAddress();
	void setDeliveryAddress(Address deliveryAddress);

	Boolean getVip();
	void setVip(Boolean vip);

	CategoryEnum getCategory();
	void setCategory(CategoryEnum category);

	BigDecimal getBuyLimit();
	void setBuyLimit(BigDecimal buyLimit);
}
