package org.openxma.demo.customer.xma.jsfcomponent.backingbean;

import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

/** 
 * Backing Bean for Page ExpressionsPage 
 */
@Component("expressionsPage")
@Scope("access")
public class ExpressionsPage extends ExpressionsPageGen {
	
	@Override
	public void dataModelInit() {
		edit = false;
	}

	@Override
	public void enable() {
		edit = true;
	}

	@Override
	public void disable() {
		edit = false;
	}
}
