package org.openxma.demo.customer.xma.jsfcomponent.backingbean;

import javax.annotation.PostConstruct;

import org.apache.myfaces.orchestra.viewController.annotations.ViewController;
import org.openxma.demo.customer.dto.CustomerView;
import org.openxma.dsl.platform.jsf.util.JsfUtil;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

/** 
 * Backing Bean for Page ValidationPage 
 */
@Component("validationPage")
@Scope("access")
@ViewController(viewIds={"pages/JsfComponent/validationPage.xhtml"})
public class ValidationPage extends ValidationPageGen {
	@PostConstruct
	public void myInitMethod() {
		System.out.println("postconstruct "+this);
		cus = new CustomerView();
	}
	
	@Override
	public void sendForm() {
		System.out.println("sendform"+this);
		JsfUtil.addMessage(null, "Sent form", "Form sent.");
		
	}
}
