package utf8check;

import java.io.UnsupportedEncodingException;

public class Checker {
	
	public static void main(String [] args) throws UnsupportedEncodingException {
		System.out.println("start");
		StringBuilder str = new StringBuilder();
		for (int i=0;i<s.length();i++) {
			char c = s.charAt(i);
			if ("\n".equals(""+c)) {
				System.out.print(str);
				byte[] ba = str.toString().getBytes("UTF-8");
				boolean valid = validUTF8(ba);
				System.out.println("   valid:" + valid);
				if (!valid)
					break;
				str = new StringBuilder();
			}
			else {
				str.append(c);
			}
		}
		System.out.print(str);
		byte[] ba = str.toString().getBytes("UTF-8");
		boolean valid = validUTF8(ba);
		System.out.println("   valid:" + valid);
		System.out.println("end");
	}
	
	
	static String s = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>"
+"\n<!DOCTYPE html"
+"\n        PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\""
 +"\n       \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">"
 +"\n<html xmlns=\"http://www.w3.org/1999/xhtml\""
+"\n	xmlns:f=\"http://java.sun.com/jsf/core\""
+"\n	xmlns:h=\"http://java.sun.com/jsf/html\""
+"\n	xmlns:ui=\"http://java.sun.com/jsf/facelets\""
+"\n	xmlns:p=\"http://primefaces.org/ui\""
+"\n	xmlns:i18n=\"http://fwv.spardat.at/i18n\""
+"\n	xmlns:fn=\"http://java.sun.com/jsp/jstl/functions\">"
+"\n<head>"
+"\n</head>"
+"\n<body>"
+"\n<ui:composition template=\"/templates/template.xhtml\">"
+"\n		<ui:param name=\"title\" value=\"CSearchPage\" />"
+"\n		<ui:define name=\"center\">"
+"\n			<h:form id=\"CSearchPageForm\">"
+"\n			<p:panelGrid columns=\"2\" id=\"sForm\">"
+"\n			<p:panelGrid columns=\"2\" id=\"customerTableHeader\">"
+"\n			<p:outputLabel id=\"headerText\" for=\"TODO:calculateReferencedElement\" />"
+"\n			<p:outputLabel value=\"First name\" for=\"\" />"
+"\n			<h:inputText value=\"#{cSearchPage.customer.firstName}\" />\""
+"\n			<p:outputLabel value=\"Last name\" for=\"\" />"
+"\n			<h:inputText value=\"#{cSearchPage.customer.lastName}\" />\""
+"\n			<p:commandButton id=\"findButton\" update=\"@form\" value=\"org.openxma.dsl.pom.model.impl.LabelTextImpl@11c5367 (label: Find)\" />"
+"\n			</p:panelGrid>"
+"\n			<p:dataTable id=\"customerTable\" "
+"\n						    value=\"#{cSearchPage.customerTableTableModel}\" var=\"item\""
+"\n						    selection=\"#{cSearchPage.customerTableTableModel.selectedItem}\">"
+"\n			<p:column headerText=\"First name\""
+"\n							    sortBy=\"#{item.firstName}\" filterBy=\"#{item.firstName}\">"
+"\n							    <h:outputText value=\"#{item.firstName}\" />"
+"\n			</p:column>"
+"\n			<p:column headerText=\"columnLabel\""
+"\n							    sortBy=\"#{}\" filterBy=\"#{}\">"
+"\n							    <h:outputText value=\"#{}\" />"
+"\n			</p:column>"
+"\n			</p:dataTable>"
+"\n			<p:separator />"
+"\n			<p:tabView id=\"tabFolder\">"
+"\n			<p:tab id=\"firstTab\" title=\"First Tab\">"
+"\n			<p:outputLabel id=\"\" for=\"TODO:calculateReferencedElement\" />"
+"\n			<h:inputText id=\"myText2\"/>"
+"\n			<p:outputLabel value=\"First Tab\" for=\"\" />"
+"\n			</p:tab>"
+"\n			<p:tab id=\"secondTab\" title=\"Second Tab\">"
+"\n			<p:outputLabel id=\"\" for=\"TODO:calculateReferencedElement\" />"
+"\n			<h:inputText id=\"myText1\"/>"
+"\n			<p:outputLabel value=\"Second Tab\" for=\"\" />"
+"\n			</p:tab>"
+"\n			</p:tabView>"
+"\n			</p:panelGrid>"
+"\n			</h:form>"
+"\n		</ui:define>"
+"\n"
+"\n	</ui:composition>"
+"\n</body>"
+"\n</html>";
	
	public static boolean validUTF8(byte[] input) {
		  int i = 0;
		  // Check for BOM
		  if (input.length >= 3 && (input[0] & 0xFF) == 0xEF
		    && (input[1] & 0xFF) == 0xBB & (input[2] & 0xFF) == 0xBF) {
		   i = 3;
		  }

		  int end;
		  for (int j = input.length; i < j; ++i) {
		   int octet = input[i];
		   if ((octet & 0x80) == 0) {
		    continue; // ASCII
		   }

		   // Check for UTF-8 leading byte
		   if ((octet & 0xE0) == 0xC0) {
		    end = i + 1;
		   } else if ((octet & 0xF0) == 0xE0) {
		    end = i + 2;
		   } else if ((octet & 0xF8) == 0xF0) {
		    end = i + 3;
		   } else {
		    // Java only supports BMP so 3 is max
		    return false;
		   }

		   while (i < end) {
		    i++;
		    octet = input[i];
		    if ((octet & 0xC0) != 0x80) {
		     // Not a valid trailing byte
		     return false;
		    }
		   }
		  }
		  return true;
		 }
}
